%{
#include <stdlib.h>
#include <string.h>
entry *install_id(char *);
%}

id [A-Za-z][A-Za-z0-9]*
const [0-9]+
ws [ \t]+
newline [\n]


%%
{ws}			/*doing nothing*/
{newline}			{lines++;}
"var"		return VAR;
"="			return('=');
"+"			return('+');
"-"			return('-');
"*"			return('*');
";"			return(';');

{id}		{				
				temp_n=n;
				yylval.id_type=install_id(yytext);
				if(n>temp_n)
					return NEW_ID;
				else return ID;
            }

{const}		{
				yylval.const_type=atoi(yytext); 
				return CONST;
            }

.			return(yytext[0]);
		
%%

entry *install_id(char *symbol_name)
	{
		entry *ptr=table;
		for(i=0;i<=n;i++)
			{
				if(strcmp(symbol_name, table[i].name)==0)
				{
					ptr=&table[i];
					return ptr;
				}
			}
		n++;
		strcpy(table[n].name,symbol_name);
		ptr=&table[n];
		return ptr;
	}
